export const CHECKS = {
    FAKE_ANTIADB_CHECK_TASK: 'FAKE_ANTIADB_CHECK_TASK',
    FAKE_ANTIADB_RULES_TASK: 'FAKE_ANTIADB_RULES_TASK',
    FAKE_ANTIADB_FROD_TASK: 'FAKE_ANTIADB_FROD_TASK',
    FAKE_ANTIADB_SCRIPTS_TASK: 'FAKE_ANTIADB_SCRIPTS_TASK',
    FAKE_ANTIADB_RPS_TASK: 'FAKE_ANTIADB_RPS_TASK',
    FAKE_ANTIADB_ERRORS_TASK: 'FAKE_ANTIADB_ERRORS_TASK',
    FAKE_ANTIADB_PERCENT_TASK: 'FAKE_ANTIADB_ERRORS_TASK'
};

export const DESCRIPTIONS = {
    FAKE_ANTIADB_CHECK_TASK: `Проверка показывает работоспособность сервиса. 
    Красный статус ничего не означает, как и зеленый.`,
    FAKE_ANTIADB_RULES_TASK: `Проверка показывает наличие и количество правил, скрывающих рекламу на сайте. 
    Красный статус означает, что есть правила, которые скрывают рекламу.`,
    FAKE_ANTIADB_FROD_TASK: `Проверка показывает уровень событий (показы, клики, деньги), помеченных, как фродовые. Причиной может быть неправильная настройка рекламного блока или кукиматчинга.
    Красный статус означает, что показатели фрода выросли.`,
    FAKE_ANTIADB_SCRIPTS_TASK: `Проверка показывает, как рекламные скрипты (учет денег, отправка статистики итд) работают с текущими настройками шифрования.
    Красный статус означает, что один или несколько рекламных скриптов работают некорректно.`,
    FAKE_ANTIADB_RPS_TASK: `Проверка показывает количество запросов, проходящих через АнтиАдблок. 
    Красный статус означает, что количество РПС значимо уменьшилось.`,
    FAKE_ANTIADB_ERRORS_TASK: `Проверка показывает количество ошибок (как клиентских, так и серверных) 
    Красный статус означает, что количество ошибок выросло.`,
    FAKE_ANTIADB_PERCENT_TASK: `Проверка показывает процент разблок в 3х разрезах: по приложениям (браузер + блокировщик), по форматам рекламы и по рекламным блокам.
    Красный статус означает, что один или несколько показателей разблока упали.`
};

export const TITLES = {
    FAKE_ANTIADB_CHECK_TASK: 'Случайная проверка',
    FAKE_ANTIADB_RULES_TASK: 'Новые правила блокировщиков',
    FAKE_ANTIADB_FROD_TASK: 'Фрод',
    FAKE_ANTIADB_SCRIPTS_TASK: 'Служебные скрипты',
    FAKE_ANTIADB_RPS_TASK: 'Количество РПС',
    FAKE_ANTIADB_ERRORS_TASK: 'Количество ошибок',
    FAKE_ANTIADB_PERCENT_TASK: 'Показатели разблока'
};

export const health = [{
    status: 'ok',
    id: 'rules',
    date: '10.05.2018',
    title: 'Новые правила блокировщиков',
    description: `Проверка показывает наличие и количество правил, скрывающих рекламу на сайте. 
    Красный статус означает, что есть правила, которые скрывают рекламу.
    Нажмите "$link", чтобы посмотреть список правил и обновить настройки подключения для обхода правил.`,
    link: '/support',
    linkText: 'Подробнее'
}, {
    status: 'ok',
    id: 'frod',
    date: '10.05.2018',
    title: 'Фрод',
    description: `Проверка показывает уровень событий (показы, клики, деньги), помеченных, как фродовые. Причиной может быть неправильная настройка рекламного блока или кукиматчинга.
    Красный статус означает, что показатели фрода выросли
    Нажмите "$link", чтобы посмотреть, какие события считаются фродами и возможные причины.`,
    link: '/support',
    linkText: 'Подробнее'
}, {
    status: 'ok',
    id: 'scripts',
    date: '10.05.2018',
    title: 'Служебные скрипты',
    description: `Проверка показывает, как рекламные скрипты (учет денег, отправка статистики итд) работают с текущими настройками шифрования.
    Красный статус означает, что один или несколько рекламных скриптов работают некорректно. 
    Нажмите "$link", чтобы обновить настройки шифрования и восстановить работу рекламных скриптов.`,
    link: '/support',
    linkText: 'Подробнее'
}, {
    status: 'ok',
    id: 'rps',
    date: '10.05.2018',
    title: 'Количество РПС',
    description: `Проверка показывает количество запросов, проходящих через АнтиАдблок. 
    Красный статус означает, что количество РПС значимо уменьшилось.
    Нажмите "$link", чтобы посмотреть графики запросов, проверить настройки проксирования.`,
    link: '/support',
    linkText: 'Подробнее'
}, {
    status: 'ok',
    id: 'errors',
    date: '10.05.2018',
    title: 'Количество ошибок',
    description: `Проверка показывает количество ошибок (как клиентских, так и серверных) 
    Красный статус означает, что количество ошибок выросло.
    Нажмите "$link", чтобы посмотреть, какие ошибки выросли и какие ссылки чаще всего возвращают ошибки.`,
    link: '/support',
    linkText: 'Подробнее'
}, {
    status: 'error',
    id: 'percent',
    date: '10.05.2018',
    title: 'Показатели разблока',
    description: `Проверка показывает процент разблок в 3х разрезах: по приложениям (браузер + блокировщик), по форматам рекламы и по рекламным блокам.
    Красный статус означает, что один или несколько показателей разблока упали.
    Нажмите "$link", чтобы посмотреть статистику разблока и поменять настройки шифрования или проксирования.`,
    link: '/support',
    linkText: 'Подробнее'
}];
