# Code of Conduct for Crowdin Contributors of Adblock Plus UI

## Overview and purpose

eyeo GmbH, the company behind Adblock Plus, believes in a fair and profitable web for everyone. We’ve long been champions of the open web and strong advocates of open source. We wholeheartedly believe that our community is pivotal to who we are as an organization. For the past seven years, we’ve relied on the generosity of you, our contributors, to translate the Adblock Plus project. We’d like to continue to ask for your help in translating Adblock Plus so that people all over the world can enjoy a faster, better web. 

Because the Adblock Plus community continues to grow, it’s now more imperative than ever that we provide you with a safe, civilized place where you can connect with other contributors and eyeo team members in an effort to improve Adblock Plus. To ensure that everyone is treated fairly, we’ve put together this Code of Conduct. We respectfully ask that you adhere to the following guidelines, which have been purposely kept short and sweet.

## Guidelines

- Always be respectful and polite. 
  - **Be open-minded**. It’s amazing what we can accomplish when we work together. Consider opinions and suggestions that differ from your own.
  - **Be respectful to one another and to eyeo team members**. It’s fine to disagree, but it’s not okay to criticize other contributors or eyeo team members. Rudeness and unprofessionalism will get you nowhere! Harassment, offensive or abusive language, bullying, or hate speech of any kind will not be tolerated.
  - **Help one another**. Contributors will appreciate any help if they asked a question or opened an issue for a string. If you’re able to, please feel free to give them a hand.
- Only submit suggestions in place of others IF your change is going to improve the previous suggestion. A translation isn’t wrong just because the word used isn’t the word you would use. Please keep in mind that in most languages there are many ways to say the same thing!
- If you believe that your change improves the previous suggestion, you must explain, in detail, *why* it’s better than the one previously suggested.
- Be practical. If you’ve been granted proofreading rights, please don’t choose your suggestion over another contributor’s suggestion just because it’s yours. Failing to adhere to this guideline three times will result in eyeo revoking your proofreading rights.
- Please only suggest or vote for translations in your native language.
- Don’t create spam. Make sure the translation you suggest is in your native language, directly relates to the source string, and isn’t a duplicate of an already suggested translation.

