---
name: Bug report
about: Create a bug report to help us improve AdGuard Browser Extension
---

<!--  As an open-source project with a dedicated but small maintainer team, it can sometimes take a long time for issues to be addressed so please be patient and we will get back to you as soon as we can.
-->

### Prerequisites

Please answer the following questions for yourself before submitting an issue. **YOU MAY DELETE THE PREREQUISITES SECTION.**

- [ ] I am running the latest version
- [ ] I checked the documentation and found no answer
- [ ] I checked to make sure that this issue has not already been filed

### Issue Details

<!--- Please include all relevant details about the environment you experienced the bug in -->

- **AdGuard version:**
  - <!-- (e.g. AdGuard v3.2.1) -->
- **Browser and version:**
  - <!-- (e.g. Chrome 75) -->
- **Operating system and version:**
  - <!-- (e.g. Windows 10) -->
- **Filters you use in AdGuard:**
  - <!-- (e.g. Base filter, Social filter, etc) -->
- **Stealth Mode settings:**
  - <!-- (if it's enabled) -->
- **Other browser extensions:**
  - <!-- (list other extensions you have installed) -->

### Expected Behavior

<!-- A clear and concise description of what you expected to happen. -->

### Actual Behavior

<!-- A clear and concise description of what actually happened. -->

### Screenshots

<!-- If applicable, add screenshots to help explain your problem. -->

<details><summary>Screenshot:</summary>

<!--- drag and drop, upload or paste your screenshot to this area-->

</details>

### Additional Information

<!-- Add any other context about the problem here. -->
